//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.access.api_1_svw_reha;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.access.*;
import sim.toolkit.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;


public class API_1_SVW_REHA_1 extends TestToolkitApplet {

    private static SIMView theSimView;

    public static byte[] resp = new byte[3];
    public static byte[] incr = new byte[3];

    /**
     * The Constructor registers the application for the Event.
     */
    private API_1_SVW_REHA_1() {
        
        // Get a reference to the SIM View.
        theSimView = SIMSystem.getTheSIMView();
        
    }

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        API_1_SVW_REHA_1 testApp = new API_1_SVW_REHA_1();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }

    /**
     * This method will be used to trigger the tests.
     * The application will be triggered by an Formatted SMS PP download event.
     * @param event 
     */
    public void processToolkit (byte event) throws ToolkitException {

        EnvelopeHandler envHdlr;
        short result = 0;
        short incrOffset;
        short respOffset;
    
        if (event == EVENT_FORMATTED_SMS_PP_ENV) {

            /*------------------------------------------------------------------
             * TEST CASE 01: No EF is selected
             *----------------------------------------------------------------*/
            try {
                theSimView.rehabilitate();
                reportTestFailure((byte)TestConstants.TESTCASE01);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE01, 
                        sve.getReason() == SIMViewException.NO_EF_SELECTED);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }
        
            /*------------------------------------------------------------------
             * TEST CASE 02: Rehabilitate invalidated File
             *----------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_DF_SIMTEST);
                theSimView.select(TestConstants.FID_EF_CNR);

                theSimView.invalidate();

                theSimView.rehabilitate();

                incrOffset = respOffset = 0;
                incr[0] = incr[1] = 0x00;
                incr[2] = (byte)0x01;
                resp[0] = resp[1] = resp[2] = 0x00;

                theSimView.increase(incr, incrOffset, resp, respOffset);
                if ((resp[0] != (byte)0x00) || (resp[1] != (byte)0x00) || 
                    (resp[2] != (byte)0x01))
                    UserException.throwIt((short)0);

                reportTestSuccess((byte)TestConstants.TESTCASE02);

            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE02);
            }

            /*------------------------------------------------------------------
             * TEST CASE 03: Access condition not fulfilled
             *----------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_CNRH);

                theSimView.invalidate();
                theSimView.rehabilitate();

                reportTestFailure((byte)TestConstants.TESTCASE03);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE03, 
                        sve.getReason() == SIMViewException.AC_NOT_FULFILLED);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE03);
            }

            /*------------------------------------------------------------------
             * TEST CASE 04: Rehabilitate validated File
             *----------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_CNR);

                // File is still rehabilitated from test case 02.
                theSimView.rehabilitate();

                reportTestFailure((byte)TestConstants.TESTCASE04);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE04, 
                        sve.getReason() == SIMViewException.INVALIDATION_STATUS_CONTRADICTION);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE04);
            }

        } // end if
    }
}
