//-----------------------------------------------------------------------------
//    FWK_API_HEPO_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_api_hepo;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : A handler is a temporary JCRE Entry Point object
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 03/12/01
 *
 */
public class FWK_API_HEPO_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};
	
	static Object staticObject;
	Object object;
	
    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public FWK_API_HEPO_1 () 
    {
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        FWK_API_HEPO_1  thisApplet = new FWK_API_HEPO_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
                
		// --------------------------------------------
		// Test Case 1 : EnvelopeHandler with static field
		testCaseNb = (byte) 1 ;

		bRes = false ;
		try {
			staticObject = EnvelopeHandler.getTheHandler();
		}
		catch (SecurityException e)    {
			bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

		// --------------------------------------------
		// Test Case 2 : EnvelopeHandler with field
		testCaseNb = (byte) 2 ;

		bRes = false ;
		try {
			object = EnvelopeHandler.getTheHandler();
		}
		catch (SecurityException e)    {
			bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

		// --------------------------------------------
		// Test Case 3 : EnvelopeResponseHandler with static field
		testCaseNb = (byte) 3 ;

		bRes = false ;
		try {
			staticObject = EnvelopeResponseHandler.getTheHandler();
		}
		catch (SecurityException e)    {
			bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

		// --------------------------------------------
		// Test Case 4 : EnvelopeResponseHandler with field
		testCaseNb = (byte) 4 ;

		bRes = false ;
		try {
			object = EnvelopeResponseHandler.getTheHandler();
		}
		catch (SecurityException e)    {
			bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

		// --------------------------------------------
		// Test Case 5 : ProactiveHandler with static field
		testCaseNb = (byte) 5 ;

		bRes = false ;
		try {
			staticObject = ProactiveHandler.getTheHandler();
		}
		catch (SecurityException e)    {
			bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

		// --------------------------------------------
		// Test Case 6 : ProactiveHandler with field
		testCaseNb = (byte) 6 ;

		bRes = false ;
		try {
			object = ProactiveHandler.getTheHandler();
		}
		catch (SecurityException e)    {
			bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

		// --------------------------------------------
		// Test Case 7 : ProactiveResponseHandler with static field
		testCaseNb = (byte) 7 ;
		//send  proactive command to have the ProactiveResponseHandler available
		ProactiveHandler.getTheHandler().initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
		(ProactiveHandler.getTheHandler()).send();

		bRes = false ;
		try {
			staticObject = ProactiveResponseHandler.getTheHandler();
		}
		catch (SecurityException e)    {
			bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

		// --------------------------------------------
		// Test Case 8 : ProactiveResponseHandler with field
		testCaseNb = (byte) 8 ;
		bRes = false ;
		try {
			object = ProactiveResponseHandler.getTheHandler();
		}
		catch (SecurityException e)    {
			bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

	}
}
