//-----------------------------------------------------------------------------
//    FWK_TIN_ACDO_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_tin_acdo;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import sim.access.*;
import javacard.framework.* ;
import sim.test.util.* ;
//import sim.test.access.*;

/**
 * Test Area : Framework_ToolkitInstallation_AccessDomain(byte event) method
 * 
 * Applet is triggered on Install (Install), EVENT_MENU_SELECTION
 *
 * @version 0.0.1 - 20/09/01
 *
 */
public class FWK_TIN_ACDO_2 extends TestToolkitApplet //implements TestConstants
{ 
	private SIMView obSim;

	/**
     * Constructor of the applet
     */
	
	public FWK_TIN_ACDO_2()
	{
		// Get a reference to the SIM View.
        obSim = SIMSystem.getTheSIMView();
	} 

	/**
     * Method called by the JCRE at the installation of the applet
     */
	public static void install(byte bArray[], short bOffset, byte bLength)
	{
		// Create a new applet instance
		FWK_TIN_ACDO_2 thisApplet = new FWK_TIN_ACDO_2();

		// Register the new applet instance to the JCRE
		thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

		// Initialise the data of the test applet
		thisApplet.init();
		
		// register instance with the EVENT_UNFORMATTED_SMS_PP_ENV event
		thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
	}

    /**
     * Method called by the SIM Toolkit Framework
     */
	public void processToolkit(byte event)
	{
		boolean bRes = true;
		byte	bTestCaseNb = (byte)0;
		byte	abRead[] = new byte[3];
		byte	abIncreaseValue[] = new byte [3];
		

		if (event == EVENT_UNFORMATTED_SMS_PP_ENV) {

			// -----------------------------------------------------------------
			//	Test Case 6 :		Select EF_TARU
			//						readBinary() with paramaters
			//						fileOffset = 0
			//						resp = abRead[]
			//						respOffset = 0
			//						respLength = 3
			//						Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)1;
			bRes = false;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TARU);

			try {
				obSim.readBinary((short)0, abRead, (short)0, (short)3);
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//	Test Case 7 :		Select EF_SMS
			//						updateRecord() with paramaters
			//						recNumber = 1
			//						mode = REC_ACC_MODE_ABSOLUTE_CURRENT
			//						recOffset = 0
			//						data = abRead[FFFFFF]
			//						dataOffset = 0
			//						dataLength = 3
			//						Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)2;
			bRes = false;

			abRead[0]=(byte)0xff;
			abRead[1]=(byte)0xff;
			abRead[2]=(byte)0xff;

			obSim.select(SIMView.FID_DF_TELECOM);
			obSim.select(SIMView.FID_EF_SMS);

			try {
				obSim.updateRecord((short)1, SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT, (short)0, abRead, (short)0, (short)3);
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//	Test Case 8 :		Select EF_ADN
			//						invalidate()
			//						Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)3;
			bRes = false;

			obSim.select(SIMView.FID_EF_ADN);

			try {
				obSim.invalidate();
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//	Test Case 9 :		Select EF_SUME
			//						rehabilitate()
			//						Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)4;
			bRes = false;

			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_SUME);

			try {
				obSim.rehabilitate();
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//	Test Case 10 :		Select EF_CNR
			//						increase() with paramaters
			//						incr = abIncreaseValue[FFFFFF]
			//						incrOffset = 0
			//						resp = abRead[]
			//						respOffset = 0
			//						Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)5;
			bRes = false;

			abIncreaseValue[0]=(byte)0xff;
			abIncreaseValue[1]=(byte)0xff;
			abIncreaseValue[2]=(byte)0xff;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_CNR);

			try {
				obSim.increase(abIncreaseValue, (short)0, abRead, (short)0);
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );


		}
	}
}