//-----------------------------------------------------------------------------
//    FWK_TIN_TMAL_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_tin_tmal ;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.framework Toolkit Installation
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 26/09/01
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.framework
 */
public class FWK_TIN_TMAL_2 extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;
        
    // Timer ID array : initially all at '0' which is not a correct Timer ID
    static byte[] timerIdBuffer ;
    
    /**
     * Constructor of the applet
     */
    public FWK_TIN_TMAL_2() 
    {
    	oReg = ToolkitRegistry.getEntry();
    }

    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
    	
    	timerIdBuffer = new byte[8];
  	
        // Create a new applet instance
        FWK_TIN_TMAL_2 thisApplet = new FWK_TIN_TMAL_2();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        
        // Result of each test
        boolean bRes = false ;
        
        // Number of tests
        byte testCaseNb;
        
	if (event == EVENT_FORMATTED_SMS_PP_ENV) {
       
        	// --------------------------------------------
        	// Test Case 3 : Allocate 4 timers     
        	testCaseNb = (byte) 1 ;
        	bRes = false ;

        	try {
            		timerIdBuffer[0] = oReg.allocateTimer();
    	    		timerIdBuffer[1] = oReg.allocateTimer();
            		timerIdBuffer[2] = oReg.allocateTimer();
            		timerIdBuffer[3] = oReg.allocateTimer();
            		bRes = true ;
        	}
		catch (Exception e) {	
			bRes = false;
		}
        	reportTestOutcome(testCaseNb, bRes) ;

        	// --------------------------------------------
        	// Test Case 4 : Allocate one more timer     
        	testCaseNb = (byte) 2 ;
        	bRes = false ;

        	try {
        	    	oReg.allocateTimer();
            	}
		catch (ToolkitException e) {
			bRes = (e.getReason()==ToolkitException.NO_TIMER_AVAILABLE);
		}
        	reportTestOutcome(testCaseNb, bRes) ;

	}
        
    }
}
