//-----------------------------------------------------------------------------
//    FWK_TIN_TMAL_3.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_tin_tmal ;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.framework Toolkit Installation
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 26/09/01
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.framework
 */
public class FWK_TIN_TMAL_3 extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;
      
    //Timer ID value range
    short MIN_TIMER_ID = 1;
    short MAX_TIMER_ID = 8;
    
    /**
     * Constructor of the applet
     */
    public FWK_TIN_TMAL_3() 
    {
    	oReg = ToolkitRegistry.getEntry();
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        FWK_TIN_TMAL_3 thisApplet = new FWK_TIN_TMAL_3();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        
        // Result of each test
        boolean bRes = false ;
        
        // Number of tests
        byte testCaseNb;

	short i, j;
        
	if (event == EVENT_FORMATTED_SMS_PP_ENV) {
       
        	// --------------------------------------------
        	// Test Case 6 : Allocate 4 timers     
        	testCaseNb = (byte) 1 ;
        	bRes = false ;

        	try {
            		FWK_TIN_TMAL_2.timerIdBuffer[4] = oReg.allocateTimer();
    	    		FWK_TIN_TMAL_2.timerIdBuffer[5] = oReg.allocateTimer();
            		FWK_TIN_TMAL_2.timerIdBuffer[6] = oReg.allocateTimer();
            		FWK_TIN_TMAL_2.timerIdBuffer[7] = oReg.allocateTimer();
            		bRes = true ;
        	}
		catch (Exception e) {	
			bRes = false;
		}
        	reportTestOutcome(testCaseNb, bRes) ;

        	// --------------------------------------------
        	// Test Case 7 : Allocate one more timer     
        	testCaseNb = (byte) 2 ;
        	bRes = false ;

        	try {
        	    	oReg.allocateTimer();
            	}
		catch (ToolkitException e) {
			bRes = (e.getReason()==ToolkitException.NO_TIMER_AVAILABLE);
		}
        	reportTestOutcome(testCaseNb, bRes) ;
        	
        	// --------------------------------------------
        	// Test Case 8 : each timerId shall be between 1 and 8 and shall be different from each other
        	testCaseNb = (byte) 3 ;
        	bRes = true ;
   
		for(i = 0; i < MAX_TIMER_ID ;i++){
			
			// each timerId shall be between 1 and 8
			if ((short)(FWK_TIN_TMAL_2.timerIdBuffer[i]) < MIN_TIMER_ID || 
					(short)(FWK_TIN_TMAL_2.timerIdBuffer[i]) > MAX_TIMER_ID ) {
				bRes = false;
			}
			
			// each timerId shall be different from each other
			for(j = (short)(i+1); j < MAX_TIMER_ID ;j++){
				if (FWK_TIN_TMAL_2.timerIdBuffer[i] == FWK_TIN_TMAL_2.timerIdBuffer[j] ) {
					bRes = false;
				}

			}
	
		}
	
		reportTestOutcome(testCaseNb, bRes) ;

	}
        
    }
}
