//-----------------------------------------------------------------------------
//    FWK_APT_EDLG_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_edlg;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering
 *
 * Applet is triggered on Install (Install, all events
 *
 */

 public class FWK_APT_EDLG_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private static boolean bRes;


    //Constructor of the applet

    public FWK_APT_EDLG_1(){
        //register to EVENT DOWNLOAD LANGUAGE SELECTION
        obReg.setEvent(EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION);

    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_APT_EDLG_1 thisApplet = new FWK_APT_EDLG_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
        //register to the EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION
        bRes=thisApplet.obReg.isEventSet(EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION);
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

        //event EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION
        if(event==EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION){

            switch(testCaseNb){

                case (byte)0x00:
                    testCaseNb=(byte)0x01;
                    reportTestOutcome(testCaseNb,bRes);
                    //TEST CASE 2:APPLET IS UNREGISTERED TO THE EVENT
                    testCaseNb=(byte)0x02;
                    try{
                        //deregister to the event EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION
                        obReg.clearEvent(EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION);
                        bRes=true;
                    }
                    catch(Exception e){
                        bRes=false;
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    // Test Case 3 : THE APPLET MUST NOT BE TRIGGERED
        	    reportTestOutcome((byte)0x03,true);
               break;
               case (byte)0x02:
                    testCaseNb=(byte)0x03;
                    bRes=false;
                    reportTestOutcome(testCaseNb,bRes);
               break;
               case (byte)0x04:
                   //TEST CASE 5: THE APPLET MUST BE TRIGGERED
                   testCaseNb=(byte)0x05;
                   bRes=true;
                   reportTestOutcome(testCaseNb,bRes);
            }
        }


        //event EVENT_FORMATTED_SMS_PP_ENV
        if(event==EVENT_FORMATTED_SMS_PP_ENV){
	    //TEST CASE 4: THE APPLET IS REGISTERED TO THE EVENT
            testCaseNb=(byte)0x04;
            try{
                //register to the event EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION
                obReg.setEvent(EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION);
                bRes=true;
            }
            catch(Exception e){
                bRes=false;
            }
            reportTestOutcome(testCaseNb,bRes);


        }

    }

 }