//-----------------------------------------------------------------------------
//    FWK_APT_EFSE_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_efse;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering
 *
 * Applet is triggered on Install (Install, all events
 *
 * @version 0.0.1 - 15/11/01
 *
 */

 public class FWK_APT_EFSE_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private boolean bRes;
     private byte nbCases =(byte)0x00;
     //private static ToolkitRegistry obReg;


    //Constructor of the applet

    public FWK_APT_EFSE_1(){
        //register to UNRECOGNIZED ENVELOPE
       // obReg=ToolkitRegistry.getEntry();
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);

    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_APT_EFSE_1 thisApplet = new FWK_APT_EFSE_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

       bRes=false;

       if(event==EVENT_FORMATTED_SMS_PP_ENV ){

        switch(nbCases){
            case (byte)0x00:
            	//TEST CASE 1: The apple is triggered
                testCaseNb=(byte)0x01;
                bRes=true;
                try{
                    //The applet is deregistered to the event 	                   
                    obReg.clearEvent(EVENT_FORMATTED_SMS_PP_ENV);                    
                    bRes=true;
                }
                catch(Exception e){
                    bRes=false;
                }
                reportTestOutcome(testCaseNb,bRes);
                reportTestOutcome((byte)0x02,true);
                nbCases++;
                break;

           case (byte)0x01:
           	//TEST CASE 2:The applet must not be triggered           	
           	//if the applet is triggered the test falls
                testCaseNb=(byte)0x02;
                bRes=false;
                reportTestOutcome(testCaseNb,bRes);
           break;
		
           case (byte)0x02:
           	//TEST CASE 4: The apple is triggered after the registration to the event
                testCaseNb=(byte)0x04;
                bRes=true;
                reportTestOutcome(testCaseNb,bRes);
        }

     }
     if(event==EVENT_UNRECOGNIZED_ENVELOPE){
        testCaseNb=0x03;
        //TEST CASE 3: The applet is registered to the event
        try{
            obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
            bRes=true;
        }
        catch(Exception e){
            bRes=false;
        }
        nbCases++;
        reportTestOutcome(testCaseNb,bRes);
     }
  }
 }