//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_fsc_cufi;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import sim.access.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;


public class FWK_FSC_CUFI_1 extends TestToolkitApplet {

    private static SIMView theSIMView;

    final static byte  CMD_QUALIFIER = (byte)0x01; //alphabet set;
    final static byte  DATA_CODING   = (byte)0x0F; //language unspecified
    final static byte[] displayText = {(byte)'w', (byte)'a', (byte)'i', (byte)'t'};

    final static byte[] buffer = {(byte) 0xCA, (byte) 0xFE};
    static byte[] buffer2 = new byte[10];

    /**
     * The Constructor register the application for the Event.
     */
    private FWK_FSC_CUFI_1() {

        // Get a reference to the SIM View.
        theSIMView = SIMSystem.getTheSIMView();

    }

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        FWK_FSC_CUFI_1 testApp = new FWK_FSC_CUFI_1();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }


    /**
     * @param event
     * In the processToolkit-function the incomming data will be processed.
     * In accordance to the tags of the TLVs, there will be processed a
     * GetInkeyCommand or an UPDATECommand. The GetInkeyCommand will be also
     * used to test the of the ProactiveResponseHandler.
     */
    public void processToolkit (byte event) throws ToolkitException {

        ProactiveHandler proHdlr;

        short dataOffset = 0;
        short dataLength = 0;
        short fileOffset = 0;
        short result = 0;

        if (event == EVENT_FORMATTED_SMS_PP_ENV) {

            proHdlr = ProactiveHandler.getTheHandler();

            /*------------------------------------------------------------------
             * TEST CASE 1: No change to file context by another applet
             *----------------------------------------------------------------*/
            try {
                // (1/3) - No exception shall be thrown.
                theSIMView.select(TestConstants.FID_DF_SIMTEST);
                theSIMView.select(TestConstants.FID_EF_TARU);

                fileOffset = 0;
                dataLength = 2;
                dataOffset = 0;
                theSIMView.updateBinary(fileOffset, buffer, dataOffset, dataLength);

                proHdlr.initGetInkey(CMD_QUALIFIER, DATA_CODING, displayText,
                                                    (short)0, (short)displayText.length);
                result = proHdlr.send();

                // (3/3) -  No exception shall be thrown.
                // The value of buffer2 is { 0xCA, 0xFE }
                Util.arrayFillNonAtomic(buffer2, dataOffset, dataLength, (byte)0);

                result = theSIMView.readBinary(fileOffset, buffer2, dataOffset, dataLength);

                if (Util.arrayCompare(buffer, (short)0, buffer2, dataOffset, dataLength) != 0) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE01);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }

            /*------------------------------------------------------------------
             * TEST CASE 2: No change to file context by subscriber session
             *----------------------------------------------------------------*/
            try {
                // (1/3) - No exception shall be thrown.
                proHdlr.initGetInkey(CMD_QUALIFIER, DATA_CODING, displayText,
                                                    (short)0, (short)displayText.length);

                // (2/3) - No exception shall be thrown.
                result = proHdlr.send();

                // (3/3) -  No exception shall be thrown.
                // The value of buffer2 is { 0xCA, 0xFE }
                Util.arrayFillNonAtomic(buffer2, dataOffset, dataLength, (byte)0);

                result = theSIMView.readBinary(fileOffset, buffer2, dataOffset, dataLength);

                if (Util.arrayCompare(buffer, (short)0, buffer2, dataOffset, dataLength) != 0) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE02);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE02);
            }

            /*------------------------------------------------------------------
             * TEST CASE 3: No change by applet of subscriber session context
             *----------------------------------------------------------------*/
            try {
                // (1/3) - No exception shall be thrown.
                theSIMView.select(TestConstants.FID_DF_SIMTEST);
                theSIMView.select(TestConstants.FID_EF_TNU);

                proHdlr.initGetInkey(CMD_QUALIFIER, DATA_CODING, displayText,
                                                    (short)0, (short)displayText.length);

                // (2/3) - No exception shall be thrown.
                result = proHdlr.send();

                // (3/3) -  No exception shall be thrown.
                reportTestSuccess((byte)TestConstants.TESTCASE03);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE03);
            }

        } // end: if (event)...

    }
}
