//-----------------------------------------------------------------------------
//    FWK_HIN_ENHD_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_hin_enhd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Integrity
 *
 * Applet is triggered on Install(Install), all events
 *
 *
 */

 public class FWK_HIN_ENHD_1 extends TestToolkitApplet{


    private static byte[]bufferCC={(byte)0x82,(byte)0x02,(byte)0x82,(byte)0x81,(byte)0x06,(byte)0x07,
                                   (byte)0x91,(byte)0x43,(byte)0x06,(byte)0x07,(byte)0x30,(byte)0x11,(byte)0xF0,(byte)0x13,
                                   (byte)0x07,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01};


     private byte testCaseNb = (byte) 0x00;

     private byte[] menuEntry1={(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'1'};
     private byte[] menuEntry2={(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'2'};
     private byte[] TEXT = {(byte)'T',(byte)'e',(byte)'x',(byte)'t',(byte)' ',(byte)'1'};
     private byte[] buffer1;
     private byte[] buffer2;
     private boolean secondTrigger=false;
     private boolean bRes;
     private byte[] eventList ={(byte)12,(byte)13,(byte)14,(byte)15,(byte)16,(byte)17,(byte)18, (byte)20, (byte)21};
     private byte value;
     private byte value2;

     private byte a;



    //Constructor of the applet

    public FWK_HIN_ENHD_1(){
         //register to EVENT_UNFORMATTED_SMS_PP_ENV
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        //register to EVENT_CALL_CONTROL_BY_SIM
        obReg.setEvent(EVENT_CALL_CONTROL_BY_SIM);
        //register to EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
        obReg.setEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);
        //register to EVENT_UNFORMATTED_SMS_CB
        obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
        //register to EVENT_MENU_SELECTION
        obReg.initMenuEntry(menuEntry1,(short)0,(short)menuEntry1.length,(byte)0,false,(byte)0,(short)0);
        //register to EVENT_MENU_SELECTION_HELP_REQUEST
        obReg.initMenuEntry(menuEntry2,(short)0,(short)menuEntry2.length,(byte)0,true,(byte)0,(short)0);
        //register to EVENT_TIMER_EXPIRATION
        for(a=0; a<(byte)8; a++){
       	   	obReg.allocateTimer();
       	}
       	for(a=2; a<(byte)9; a++){
       	   	obReg.releaseTimer((byte)a);
       	}
        //register to all event download
        obReg.setEventList(eventList,(short)0,(short)eventList.length);
        //register to EVENT_UNRECOGNIZED_ENVELOPE
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
        //register to EVENT_FORMATTED_SMS_CB
        obReg.setEvent(EVENT_FORMATTED_SMS_CB);

       buffer1=new byte[(byte)0x7F];
       buffer2=new byte[(byte)0x7F];


    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_HIN_ENHD_1 thisApplet = new FWK_HIN_ENHD_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

        bRes=true;

        //the handler contents is stored in buffer 1
        EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
        try{
             envHdlr.copy(buffer1,(short)0,envHdlr.getLength());
        }
        catch(Exception e){
            bRes=false;
        }

        //for each event a tlv is selected the first byte is stored
        if(!secondTrigger && bRes){

            switch(event){

                //event EVENT_MENU_SELECTION_HELP_REQUEST
                case EVENT_MENU_SELECTION_HELP_REQUEST:
                    if(envHdlr.findTLV((byte)(TAG_HELP_REQUEST|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value = (byte)0x00;
                break;

                //event EVENT_MENU_SELECTION
                case EVENT_MENU_SELECTION:
                    if(envHdlr.findTLV((byte)(TAG_ITEM_IDENTIFIER|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value = (byte)0x01;
                break;

                //event EVENT_FORMATTED_SMS_PP_ENV
                case EVENT_FORMATTED_SMS_PP_ENV:
                    if(envHdlr.findTLV((byte)(TAG_SMS_TPDU | TAG_SET_CR) ,(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value=(byte)0x40;

                break;

                //event EVENT_UNFORMATTED_SMS_PP_ENV
                case EVENT_UNFORMATTED_SMS_PP_ENV:
                    if(envHdlr.findTLV((byte)(TAG_DEVICE_IDENTITIES|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value = (byte)0x83;
                break;

                //event EVENT_UNFORMATTED_SMS_CB
                case EVENT_UNFORMATTED_SMS_CB:
                    if(envHdlr.findTLV((byte)(TAG_CELL_BROADCAST_PAGE|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value =(byte)0x00;
                break;

                //event EVENT_TIMER_EXPIRATION
                case EVENT_TIMER_EXPIRATION:
                   if(envHdlr.findTLV((byte)(TAG_TIMER_IDENTIFIER|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                    bRes=false;
                   }
                   value = (byte)0x01;
                break;

                //event EVENT_CALL_CONTROL_BY_SIM
                case EVENT_CALL_CONTROL_BY_SIM:
                    if(envHdlr.findTLV((byte)(TAG_ADDRESS|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value = (byte) 0x91;
                break;

                //event EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
                case EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM:
                    if(envHdlr.findTLV((byte)(TAG_ADDRESS|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value =(byte)0x91;
                break;

                //event EVENT_EVENT_DOWNLOAD_MT_CALL
                case EVENT_EVENT_DOWNLOAD_MT_CALL:
                    if(envHdlr.findTLV((byte)(TAG_ADDRESS|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value =(byte)0x80;
                break;

                //event EVENT_EVENT_DOWNLOAD_CALL_CONNECTED
                case EVENT_EVENT_DOWNLOAD_CALL_CONNECTED:
                    if(envHdlr.findTLV((byte)(TAG_ADDRESS|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value = (byte)0x80;
                break;

                //event EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED
               case EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED:
                    if(envHdlr.findTLV((byte)(TAG_ADDRESS|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value =(byte)0x80;
                break;

                //event EVENT_EVENT_DOWNLOAD_LOCATION_STATUS
                case EVENT_EVENT_DOWNLOAD_LOCATION_STATUS:
                    if(envHdlr.findTLV((byte)(TAG_LOCATION_STATUS|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value =(byte)0x01;
                break;

                //event EVENT_EVENT_DOWNLOAD_USER_ACTIVITY
                case EVENT_EVENT_DOWNLOAD_USER_ACTIVITY:
                    if(envHdlr.findTLV((byte)(TAG_DEVICE_IDENTITIES|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value =(byte)0x82;
                break;

                //event EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE
                case EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE:
                    if(envHdlr.findTLV((byte)(TAG_DEVICE_IDENTITIES|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value =(byte)0x02;
                break;

                //event EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS
                case EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS:
                    if(envHdlr.findTLV((byte)(TAG_CARD_READER_STATUS|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value=(byte)0xFF;
                break;


                // ** Statements added for release 4
                //event EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION
                case EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION:
                    if(envHdlr.findTLV((byte)(TAG_EVENT_LIST|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value=(byte)0x07;
                break;

                //event EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION
                case EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION:
                    if(envHdlr.findTLV((byte)(TAG_EVENT_LIST|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value=(byte)0x08;
                break;

                //event EVENT_FORMATTED_SMS_CB
                case EVENT_FORMATTED_SMS_CB:
                    if(envHdlr.findTLV((byte)(TAG_CELL_BROADCAST_PAGE|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
                        bRes=false;
                    }
                    value=(byte)0xC0;
                break;
                // ** End of statements added for release 4


//            EVENT_UNRECOGNIZED_ENVELOPE:
//                NO TLV IS SELECTED



             }

             if(bRes){
                //A Display text is sent
                 secondTrigger=true;
                 ProactiveHandler prHdlr = ProactiveHandler.getTheHandler();
                 prHdlr.initDisplayText((byte)0x80,DCS_8_BIT_DATA,TEXT,(short)0,(short)TEXT.length);
                 prHdlr.send();
                 //the handler contents is stored in buffer 2
                 if(bRes)
                 {
                     if(event==EVENT_MENU_SELECTION_HELP_REQUEST){
                 	//Copy the envelope contents in buffer 2
	                envHdlr.copy(buffer2,(short)0,envHdlr.getLength());
	               	//the contents of buffer1 and buffer2 must be equals
	               if((byte)Util.arrayCompare(buffer1,(short)0,buffer2,(short)0,(short)envHdlr.getLength())==0){
	               	 bRes=false;
	               }
                     }
                     else{
	                   try{
	                            //the selected tlv is the same before the call control execution
	                            if(envHdlr.getValueByte((short)0)==(byte)value){

									//Copy the envelope contents in buffer 2
									envHdlr.copy(buffer2,(short)0,envHdlr.getLength());
	                            	//the contents of buffer1 and buffer2 must be equals
	                            	if((byte)Util.arrayCompare(buffer1,(short)0,buffer2,(short)0,(short)envHdlr.getLength())==0){
										bRes=false;
	                            	}
	                            }
	                            else{
	                            	bRes=false;
	                            }

	                     }
	                     catch(ToolkitException e){
	                        //if the event is an UNRECOGNIZED envelope no TLV is selected
	                        if(event==EVENT_UNRECOGNIZED_ENVELOPE && e.getReason()==ToolkitException.UNAVAILABLE_ELEMENT ){
	                            bRes=true;
	                        }
	                        else{
	                            bRes=false;
	                        }
	                    }
	                    catch(Exception e){
	                        bRes=false;
	                    }
	             }
               }

             }
             testCaseNb++;
             //create the table of results
             reportTestOutcome(testCaseNb,bRes);

        }
        //The applet is triggered when a EVENT CALL CONTROL is sent
        else{
             secondTrigger=false;
             try{
	             EnvelopeHandler envHdlrCC = EnvelopeHandler.getTheHandler();

	             //the handler contents is stored
	             envHdlrCC.copy(buffer2,(short)0,(short)envHdlrCC.getLength());

	             //is checked that the envelope is a call control
		     if(Util.arrayCompare(buffer2,(short)0x00,bufferCC,(short)0x00,(short)envHdlrCC.getLength())!=0){
	                bRes=false;
	             }
	             //the device identities TLV is selected
	             if(envHdlrCC.findTLV((byte)(TAG_DEVICE_IDENTITIES|TAG_SET_CR),(byte)1)==TLV_NOT_FOUND){
	                 bRes=false;
	             }
             }
	     catch(Exception e){
	     	 bRes=false;
	     }
        }
   }
}