
//-----------------------------------------------------------------------------
//    API_2_TKR_ATIM_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_atim;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.allocateTimer(byte timerID) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 15/01/01
 *
 */
public class API_2_TKR_ATIM_2 extends TestToolkitApplet
{

	// -----------------------------------------------------------------
	// Applet was installed with max timer parameter equals to 4
	// -----------------------------------------------------------------

	//Timer ID value range
	private	static short MIN_TIMER_ID = 1;
	private	static short MAX_TIMER_ID = 8;

	// Timer ID array : initially all at '0' which is not a correct Timer ID
	short[] Timers = {(short)0,(short)0,(short)0,(short)0};
	
    /**
     * Constructor of the applet
     */
    public API_2_TKR_ATIM_2() 
    {
    }

    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_TKR_ATIM_2 thisApplet = new API_2_TKR_ATIM_2();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

	 /**
      * Method called by the processToolkit to know if short <temp>
	  * has alread been added to an array <Array>
      */
    private boolean isInArray(short temp, short[] Array)
	{
		boolean isInArray = false;

		for(short i = ((short) (Array.length-1));
			((i > (short) -1) && (!isInArray));i--){
			isInArray = (Array[i] == temp);
		}
		return isInArray;
	}

	 /**
      * Method called by the processToolkit to know if an ID
	  * belongs to the timer ID interval
      */
    private boolean isTimerID(short ID)
	{
		boolean isTimerID;

		isTimerID = (ID>(short)(MIN_TIMER_ID-1)) && (ID<(short)(MAX_TIMER_ID+1));
		return isTimerID;
	}

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;

        // Number of tests
        byte testCaseNb = (byte) 0x01;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

        ProactiveResponseHandler proRespHdlr = null ;
    
		short temp = 0;
		short i;

			// -----------------------------------------------------------------
			// Test Case 4 :
			//					4 * allocateTimer()
			//					No exception shall be thrown. 
			//					Timer ID returned shall be between 
			//					0x01 and 0x08 inclusive. 
			//					It shall be different after each call.
			// -----------------------------------------------------------------
        
			testCaseNb = (byte) 1 ;
			bRes = false;

			try{
				temp = obReg.allocateTimer();
			}
			catch (Exception e) {
			}

			bRes = (isTimerID(temp)) && (!this.isInArray(temp,Timers));
			Timers[0] = temp;

			try{
				for (i =((short) 1); (i<((short) 4)) && (bRes);i++){
			
					temp = obReg.allocateTimer();
					bRes = (isTimerID(temp)) && (!this.isInArray(temp,Timers));
					Timers[i] = temp;
				}
			}
			catch (Exception e) {	
				bRes = false;
			}

			for (i =((short) 0); (i<((short) 4)) && (bRes);i++){
			
				if (isTimerID(Timers[i])){
					
					try{
						obReg.releaseTimer((byte) Timers[i]);
					}
					catch (Exception e) {
					}
				}
			}

			reportTestOutcome(testCaseNb, bRes) ;
	} 
}
