//-----------------------------------------------------------------------------
//    API_2_TKR_EMETB_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_emetb;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.enableMenuEntry(byte id) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 15/01/01
 *
 */
public class API_2_TKR_EMETB_1 extends TestToolkitApplet
{

	   
	private static byte [] MenuInit = 
							{	(byte) 'I',
								(byte) 'n',
								(byte) 'i',
								(byte) 't'};

    // Result of tests
    boolean bRes = false;

	// Number of tests
    byte testCaseNb = (byte) 5;

	// Trigger number.
	private byte callNb = (byte) 0;

	private byte resultat = (byte) 0;        
	
	/**
     * Constructor of the applet
     */
    public API_2_TKR_EMETB_1() 
    {
		
		resultat = obReg.initMenuEntry(MenuInit, (short) 0, 
										(short) 4, (byte) 0, false, 
										(byte) 0, (short) 0);

		resultat = obReg.initMenuEntry(MenuInit, (short) 0, 
									   (short) 4, (byte) 0, false, 
									   (byte) 0, (short) 0);
    }

    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_TKR_EMETB_1 thisApplet = new API_2_TKR_EMETB_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event)
    {
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

        ProactiveResponseHandler proRespHdlr = null ;

		short i;

		// Increasing the trigger counter.
		++callNb;

		switch(callNb)
		{
		case (byte) 1 :

			// -----------------------------------------------------------------
			// Test Case 1 :	Check menu state before enabling a previously
			//					disabed entry not registered to
			//					EVENT_MENU_SELECTION_HELP_REQUEST.
			//
			//					1-	isEventSet(EVENT_MENU_SELECTION)
			//						Shall return true
			//					2-	isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST)
			//						Shall return false
			//					3-	disableMenuEntry(01)
			// -----------------------------------------------------------------

			testCaseNb = (byte) 1;
			bRes = false;

			// -----------------------------------------------------------------
			//					1-	isEventSet(EVENT_MENU_SELECTION)
			//						Shall return true
			//					2-	isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST)
			//						Shall return false
			// -----------------------------------------------------------------

			bRes = obReg.isEventSet(EVENT_MENU_SELECTION) &&
				  !obReg.isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST);

			// -----------------------------------------------------------------
			//					3-	disableMenuEntry(01)
			//						No exception shall be thrown
			// -----------------------------------------------------------------

			if (bRes){

				bRes = false;
				try{
					obReg.disableMenuEntry((byte)0x01);
					bRes = true;
				}
				catch (Exception e) { bRes = false; }
			}

			reportTestOutcome(testCaseNb, bRes) ;
			break;

		case (byte) 2 :

			// -----------------------------------------------------------------
			// Test case 2 :	Check menu state after enabling a previously
			//					disabled entry not registered to
			//					EVENT_MENU_SELECTION_HELP_REQUEST.
			//
			//					1-	enableMenuEntry(01)
			//						No exception shall be thrown
			//					2-	isEventSet(EVENT_MENU_SELECTION)
			//						Shall return true
			//					3-	isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST)
			//						Shall return false
			// -----------------------------------------------------------------

			testCaseNb = (byte) 2;
			bRes = false;

			// -----------------------------------------------------------------
			//					1-	enableMenuEntry(01)
			//						No exception shall be thrown
			// -----------------------------------------------------------------

			try{
				obReg.enableMenuEntry((byte) 0x01);
				bRes = true;
			}
			catch (Exception e) { bRes = false; }

			// -----------------------------------------------------------------
			//					2-	isEventSet(EVENT_MENU_SELECTION)
			//						Shall return true
			//					3-	isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST)
			//						Shall return false
			// -----------------------------------------------------------------

			bRes = bRes &&
				   obReg.isEventSet(EVENT_MENU_SELECTION) &&
				  !obReg.isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST);
			
			reportTestOutcome(testCaseNb, bRes) ;
			break;

		case (byte) 3 :

			// -----------------------------------------------------------------
			// Test Case 3 :	Check menu state after enabling a previously
			//					enabled entry registered to
			//					EVENT_MENU_SELECTION_HELP_REQUEST. 
			//
			//
			//					1-  changeMenuEntry(02) to indicate help is supported.
			//					2-	isEventSet(EVENT_MENU_SELECTION)
			//						Shall return true
			//					3-	isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST)
			//						Shall return true
			//					4-	disableMenuEntry(02)
			//						No exception shall be thrown
			// -----------------------------------------------------------------

			testCaseNb = (byte) 3;
			bRes = false;

			// -----------------------------------------------------------------
			//					1-  changeMenuEntry(02) to indicate help is supported.
			// -----------------------------------------------------------------


			try {
				obReg.changeMenuEntry((byte)0x02,
									  MenuInit, (short)0, (short)4,
									  (byte)0,
									  true,
									  (byte)0, (short)0);
				bRes = true;
			}
			catch(Exception e) { bRes = false; }

			// -----------------------------------------------------------------
			//					2-	isEventSet(EVENT_MENU_SELECTION)
			//						Shall return true
			//					3-	isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST)
			//						Shall return true
			// -----------------------------------------------------------------

			bRes = bRes &&
				   obReg.isEventSet(EVENT_MENU_SELECTION) &&
				   obReg.isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST);

			// -----------------------------------------------------------------
			//					4-	disableMenuEntry(02)
			//						No exception shall be thrown
			// -----------------------------------------------------------------

			if (bRes){

				bRes = false;
				try{
					obReg.disableMenuEntry((byte)0x02);
					bRes = true;
				}
				catch (Exception e) { bRes = false; }
			}

			reportTestOutcome(testCaseNb, bRes) ;
			break;

		case (byte) 4 :

			// -----------------------------------------------------------------
			//	Test case 4 :	Check menu state before enabling a previously
			//					enabled entry registered to
			//					EVENT_MENU_SELECTION_HELP_REQUEST.
			//
			//					1-	enableMenuEntry(02)
			//						No exception shall be thrown
			//					2-	isEventSet(EVENT_MENU_SELECTION)
			//						Shall return true
			//					3-	isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST)
			//						Shall return true
			// -----------------------------------------------------------------

			testCaseNb = (byte) 4;
			bRes = false;

			// -----------------------------------------------------------------
			//					1-	enableMenuEntry(02)
			//						No exception shall be thrown
			// -----------------------------------------------------------------

			try{
				obReg.enableMenuEntry((byte) 0x02);
				bRes = true;
			}
			catch (Exception e) { bRes = false; }

			// -----------------------------------------------------------------
			//					2-	isEventSet(EVENT_MENU_SELECTION)
			//						Shall return true
			//					3-	isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST)
			//						Shall return true
			// -----------------------------------------------------------------

			bRes = bRes &&
				   obReg.isEventSet(EVENT_MENU_SELECTION) &&
				   obReg.isEventSet(EVENT_MENU_SELECTION_HELP_REQUEST);

			reportTestOutcome(testCaseNb, bRes);
			break;

		case (byte) 5 :

			// -----------------------------------------------------------------
			// Test Case 5 :	Enabling invalid entries
			//
			//					For ID ranging from 00 to FF except 01 and 02, 
			//					the applet calls disableMenuEntry(ID) method
			//					Each time a Toolkit Exception with 
			//					MENU_ENTRY_NOT_FOUND reason code shall be thrown
			// -----------------------------------------------------------------

			testCaseNb = (byte) 5;
			bRes = false;

			try{ obReg.enableMenuEntry((byte) 0); }			
			catch (ToolkitException e) {
				bRes = (e.getReason()==ToolkitException.MENU_ENTRY_NOT_FOUND);
			}			
			catch (Exception e) { bRes = false; }

			if (bRes){

				for (i = 3; (i<256) && bRes;i++){

					bRes = false;
					try{ obReg.enableMenuEntry((byte) i); }
					catch (ToolkitException e) {
						bRes = (e.getReason()==ToolkitException.MENU_ENTRY_NOT_FOUND);
					}
					catch (Exception e) { bRes = false; }
				}
			}

			reportTestOutcome(testCaseNb, bRes) ;

		} // Switch end.
	}
}
