//-----------------------------------------------------------------------------
//    API_2_TKR_GPOL_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_gpol;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.getPollInterval() method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 15/01/01
 *
 */
public class API_2_TKR_GPOL_1 extends TestToolkitApplet
{

	private byte resultat = (byte) 0;

	// Result of tests
    boolean bRes ;

	// Number of tests
    byte testCaseNb = (byte) 0x04;

	// Trigger number.
	byte callNb = (byte)0;

	/**
     * Constructor of the applet
     */
    public API_2_TKR_GPOL_1() 
    {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_TKR_GPOL_1 thisApplet = new API_2_TKR_GPOL_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }


    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

        ProactiveResponseHandler proRespHdlr = null ;

		short i;

		// Increase the trigger number.
		++callNb;

		switch(callNb)
		{
		case (byte) 1 :

			// -----------------------------------------------------------------
			// Test Case 1 :	Applet isn't registered to EVENT_STATUS_COMMAND 
			//					getPollInterval()
			//					Shall returns 0
			// -----------------------------------------------------------------

			testCaseNb = (byte) 1;
		
			reportTestOutcome(testCaseNb, obReg.getPollInterval() == 0);

			break;

		case (byte) 2 :

			// -----------------------------------------------------------------
			// Test Case 2 :	Requesting max duration
			//					1-	requestPollInterval(15300) 
			//						No exception shall be thrown
			//					2-	getPollInterval
			//						Shall return a value between 1 and 15300
			// -----------------------------------------------------------------

			testCaseNb = (byte) 2;
			bRes = false;

			// -----------------------------------------------------------------
			//					1-	requestPollInterval(15300) 
			//						No exception shall be thrown
			// -----------------------------------------------------------------

			try{
				obReg.requestPollInterval((short) 15300);
				bRes = true;
			}
			catch (Exception e){
				bRes = false;
			}

			break;

		case (byte) 3 :

			// -----------------------------------------------------------------
			//					2-	getPollInterval
			//						Shall return a value between 1 and 15300
			// -----------------------------------------------------------------

			reportTestOutcome(testCaseNb, bRes && (obReg.getPollInterval() > 0)
											&& (obReg.getPollInterval() < 15301));

			break;

		case (byte) 4 :

			// -----------------------------------------------------------------
			// Test Case 3 :	Requesting System Duration
			//					1-	requestPollInterval(POLL_SYSTEM_DURATION)
			//						No exception shall be thrown
			//					2-	getPollInterval()
			//						Shall return a value between 1 and 15300
			// -----------------------------------------------------------------

			testCaseNb = (byte) 3;
			bRes = false;

			// -----------------------------------------------------------------
			//					1-	requestPollInterval(POLL_SYSTEM_DURATION)
			//						No exception shall be thrown
			// -----------------------------------------------------------------

			try{
				obReg.requestPollInterval(POLL_SYSTEM_DURATION);
				bRes = true;
			}
			catch (Exception e){
				bRes = false;
			}

			break;

		case (byte) 5 :

			// -----------------------------------------------------------------
			//					2-	getPollInterval()
			//						Shall return a value between 1 and 15300
			// -----------------------------------------------------------------

			reportTestOutcome(testCaseNb, bRes && (obReg.getPollInterval() > 0)
											&& (obReg.getPollInterval() < 15301)) ;

			break;

		case (byte) 6 :

			// -----------------------------------------------------------------
			// Test Case 4 :	Requesting no Duration
			//					1-	requestPollInterval(POLL_NO_DURATION)
			//						No exception shall be thrown
			//					2-	getPollInterval()
			//						Shall return 0
			// -----------------------------------------------------------------


			testCaseNb = (byte) 4;
			bRes = false;

			// -----------------------------------------------------------------
			//					1-	requestPollInterval(POLL_NO_DURATION)
			//						No exception shall be thrown
			// -----------------------------------------------------------------

			try{
				obReg.requestPollInterval(POLL_NO_DURATION);
				bRes = true;
			}
			catch (Exception e){
				bRes = false;
			}

			break;

		case (byte) 7 :

			// -----------------------------------------------------------------
			//					2-	getPollInterval()
			//						Shall return 0
			// -----------------------------------------------------------------

			reportTestOutcome(testCaseNb, bRes && (obReg.getPollInterval() == 0));
		} // End switch.
	}
}
