//-----------------------------------------------------------------------------
//    API_2_TKR_SEVTB_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_sevtb;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.setEvent(byte event) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_TKR_SEVTB_2 extends TestToolkitApplet
{
	
    /**
     * Constructor of the applet
     */
    public API_2_TKR_SEVTB_2() 
    {
}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_TKR_SEVTB_2 thisApplet = new API_2_TKR_SEVTB_2();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;

        // Number of tests
        byte testCaseNb = (byte) 0x03;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

        ProactiveResponseHandler proRespHdlr = null ;
    
		// -----------------------------------------------------------------
		// Test Case 12 :Applet 2 is triggered by ENVELOPE(SMS_ PP_DOWNLOAD) 
		// -----------------------------------------------------------------

		testCaseNb = (byte) 1 ;
		reportTestSuccess(testCaseNb) ;

		// -----------------------------------------------------------------
		// Test Case 13 :	SetEvent(EVENT_CALL_CONTROL_BY_SIM)
		//					Shall throw a ToolkitException 
		//					with EVENT_ALREADY_REGISTERED reason code
		// -----------------------------------------------------------------
        
		testCaseNb = (byte) 2 ;
		bRes = false;

		try {
				obReg.setEvent(EVENT_CALL_CONTROL_BY_SIM);
		}
		catch (ToolkitException e) {	
			bRes = (e.getReason()==ToolkitException.EVENT_ALREADY_REGISTERED);
		}
		catch (Exception e) {
			bRes = false;
		}

		reportTestOutcome(testCaseNb, bRes) ;
	

		// -----------------------------------------------------------------
		// Test Case 14 :	SetEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM)
		//					Shall throw a ToolkitException 
		//					with EVENT_ALREADY_REGISTERED reason code
		// -----------------------------------------------------------------
        
		testCaseNb = (byte) 3 ;
		bRes = false;

		try {
				obReg.setEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);
		}
		catch (ToolkitException e) {
				bRes = (e.getReason()==ToolkitException.EVENT_ALREADY_REGISTERED);
		}
		catch (Exception e) {
			bRes = false;
		}

		reportTestOutcome(testCaseNb, bRes) ;
	}
}

