//-----------------------------------------------------------------------------
//    API_2_ENH_GSDL_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_gsdl;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeHandler.getSecuredDataLength()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_ENH_GSDL_1  extends TestToolkitApplet
{

	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_GSDL_1 () 
    {
		// Set Formatted SMS PP UPD as an activation event for the applet
        obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
		
		// Set Formatted SMS CB as an activation event for the applet
        obReg.setEvent(EVENT_FORMATTED_SMS_CB);
		
		// Set Unformatted SMS CB as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
		
		// Set Unformatted SMS PP as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_GSDL_1  thisApplet = new API_2_ENH_GSDL_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
			case (byte) 0 :
			case (byte) 1 :
			case (byte) 2 :
				// --------------------------------------------
				// Test Case 1-3 : getSecuredDataLength with various length of TP-OA:2,6 and 12

				bRes = false ;
				testCaseNb++;
				try {
					if (envHdlr.getSecuredDataLength() == 0x2A)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 3 :
			case (byte) 4 :
				// --------------------------------------------
				// Test Case 4-5 : getSecuredDataLength with various length of RC/CC/DS 0 and 8
				bRes = false ;
				testCaseNb++;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		
			case (byte) 5 :
				// --------------------------------------------
				// Test Case 6 : getSecuredDataLength with PCNTR = 0 
				testCaseNb = (byte) 6 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			case (byte) 6 :
				// --------------------------------------------
				// Test Case 7 : getSecuredDataLength with PCNTR = 7 
				testCaseNb = (byte) 7 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 7 :
				// --------------------------------------------
				// Test Case 8 : getSecuredDataLength with length = 0
				testCaseNb = (byte) 8 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x00)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			case (byte) 8 :
				// --------------------------------------------
				// Test Case 9 : User data length = 0x33 
				testCaseNb = (byte) 9 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x33)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 9 :
				// --------------------------------------------
				// Test Case 10 : getSecuredDataLength with length = 7F
				testCaseNb = (byte) 10 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x6C)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 10 :
				// --------------------------------------------
				// Test Case 11 : getSecuredDataLength with length = 80
				testCaseNb = (byte) 11 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x6D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 11 :
				// --------------------------------------------
				// Test Case 12 : getSecuredDataLength with the maximumlength
				testCaseNb = (byte) 12 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x79)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 12 :
				// --------------------------------------------
				// Test Case 13 : getSecuredDataLength with 2 TPDU TLV
				testCaseNb = (byte) 13 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 13 :
			case (byte) 14 :
			case (byte) 15 :
				// --------------------------------------------
				// Test Case 14-16 : getSecuredDataLength with various length of TP-OA:2,6 and 12
				testCaseNb++;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x2A)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		
			case (byte) 16 :
			case (byte) 17 :
				// --------------------------------------------
				// Test Case 17-18 : getSecuredDataLength with various length of RC/CC/DS 0 and 8
				testCaseNb++;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		
			case (byte) 18 :
				// --------------------------------------------
				// Test Case 19 : getSecuredDataLength with PCNTR =0 
				testCaseNb = (byte) 19 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 19 :
				// --------------------------------------------
				// Test Case 20 : getSecuredDataLength with PCNTR =7 
				testCaseNb = (byte) 20 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 20 :
				// --------------------------------------------
				// Test Case 21 : getSecuredDataLength with length = 0
				testCaseNb = (byte) 21 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x00)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 21 :
				// --------------------------------------------
				// Test Case 22 : User data length = 0x33 
				testCaseNb = (byte) 22 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x20)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 22 :
				// --------------------------------------------
				// Test Case 23 : getSecuredDataLength with length = 7F
				testCaseNb = (byte) 23 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x6C)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 23 :
				// --------------------------------------------
				// Test Case 24 : getSecuredDataLength with length = 80
				testCaseNb = (byte) 24 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x6D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 24 :
				// --------------------------------------------
				// Test Case 25 : getSecuredDataLength with the maximumlength
				testCaseNb = (byte) 25 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x79)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 25 :
				// --------------------------------------------
				// Test Case 26 : getSecuredDataLength with 2 TPDU TLV
				testCaseNb = (byte) 26 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte)26 :
			case (byte)27 :
				// --------------------------------------------
				// Test Case 27-28 : getSecuredDataLength with various length of RC/CC/DS 0 and 8
				bRes = false ;
				testCaseNb++;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)     {
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
				
			case (byte)28 :
				// --------------------------------------------
				// Test Case 29 : getSecuredDataLength with PCNTR = 0 
				testCaseNb = (byte) 29 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)     {
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
				
			case (byte)29 :
				// --------------------------------------------
				// Test Case 30 : getSecuredDataLength with PCNTR = 7 
				testCaseNb = (byte) 30 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)     {
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
				
			case (byte)30 :
				// --------------------------------------------
				// Test Case 31 : getSecuredDataLength with length = 0
				testCaseNb = (byte) 31 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x00)
						bRes = true;
				}
				catch (Exception e)     {
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
				
			case (byte)31 :
				// --------------------------------------------
				// Test Case 32 : User data length = 0x33 
				testCaseNb = (byte) 32 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x33)
						bRes = true;
				}
				catch (Exception e)     {
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
				
			case (byte)32 :
				// --------------------------------------------
				// Test Case 33 : getSecuredDataLength with the maximumlength
				testCaseNb = (byte) 33 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x42)
						bRes = true;
				}
				catch (Exception e)     {
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
				
			case (byte) 33 :
				// --------------------------------------------
				// Test Case 34 : findTLV device Identities (Formatted SMS PP envelope)
				testCaseNb = (byte) 34 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getSecuredDataLength() == 0x05)&&
						(envHdlr.getValueByte((short)0)==0x40))
											bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 34 :
				// --------------------------------------------
				// Test Case 35 : findTLV device Identities (Formatted SMS CB envelope)
				testCaseNb = (byte) 35 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getSecuredDataLength() == 0x05)&&
						(envHdlr.getValueByte((short)0)==0x00))
											bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
	
			case (byte) 35:
				// --------------------------------------------
				// Test Case 36 : try to apply the getSecuredDataLength method on an Unformatted SMS CB envelope
				testCaseNb = (byte) 36 ;

				bRes = false ;
				try {
					short returnvalue = envHdlr.getSecuredDataLength();
				}
				catch (ToolkitException e)    {
					if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT ) 
						bRes = true ;
					else
						bRes = false ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 36 :
				// --------------------------------------------
				// Test Case 37 : try to apply the getSecuredDataLength method on an Unformatted SMS PP envelope
				testCaseNb = (byte) 37 ;

				bRes = false ;
				try {
					short returnvalue = envHdlr.getSecuredDataLength();
				}
				catch (ToolkitException e)    {
					if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT ) 
						bRes = true ;
					else
						bRes = false ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		}
	}
}
