//-----------------------------------------------------------------------------
//	API_2_MEP_CHEC_BSS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//	Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_mep_chec_bss;


//-----------------------------------------------------------------------------
//	Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;
/**
 */
public class API_2_MEP_CHEC_BSS_1 extends TestToolkitApplet {

		 private static final byte [] COMPARE = {
        (byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,
        (byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0x7F
        };

    /**
     * Constructor of the applet
     */
    public API_2_MEP_CHEC_BSS_1() {

	// Set Formatted Update Record as an activation event for the applet
	obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);

	}

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance.
        API_2_MEP_CHEC_BSS_1 thisApplet = new API_2_MEP_CHEC_BSS_1();

        // Register the new applet instance to the JCRE.
        thisApplet.register(bArray, (short)(bOffset+1), (byte)bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();

    }

	/**
       * Method called by the SIM Toolkit Framework
	 */
	public void processToolkit(byte event) {
		byte testCaseNb = (byte) 0x00 ;
        // Result of tests
        boolean bRes = false;

		if (event == EVENT_UNFORMATTED_SMS_PP_UPD) {
		    /** Test Case 1 : ToolkitException ME_PROFILE_NOT_AVAILABLE is sent */
				testCaseNb = (byte) 1 ;
				bRes = false;

				try {
					try {
						MEProfile.check((byte)1);
					}
					catch (ToolkitException e) {
						if (e.getReason() == ToolkitException.ME_PROFILE_NOT_AVAILABLE) {
                    			bRes = true ;
							}
					}
        		}
        		catch (Exception e) {
         			  bRes = false ;
					}

				reportTestOutcome(testCaseNb, bRes);
			}

		if (event == EVENT_FORMATTED_SMS_PP_ENV) {

                /** Test Case 2 : NULL as parameter to check*/
				testCaseNb = (byte)2 ;
				bRes = false;

				try {
					MEProfile.check(null,(short)0,(short)1);
				}
				catch (NullPointerException e){
					bRes = true;
				}

				reportTestOutcome(testCaseNb, bRes);

				/** Test Case 3 : Offset > COMPARE.length */
				testCaseNb = (byte)3 ;
				bRes = false;

				try {
					MEProfile.check(COMPARE,(short)17,(short)1);
				}
				catch (ArrayIndexOutOfBoundsException e){
					bRes = true;

				}

				reportTestOutcome(testCaseNb, bRes);

                /** Test Case 4 : Offset < 0*/
				testCaseNb = (byte)4 ;
				bRes = false;

				try {
					MEProfile.check(COMPARE,(short)-1,(short)1);
				}
				catch (ArrayIndexOutOfBoundsException e){
					bRes = true;

				}

				reportTestOutcome(testCaseNb, bRes);

				/** Test Case 5 : Length > COMPARE.length */
				testCaseNb = (byte) 5 ;
				bRes = false;

				try {
					MEProfile.check(COMPARE,(short)0,(short)18);
				}
				catch (ArrayIndexOutOfBoundsException e){
					bRes = true;

				}

				reportTestOutcome(testCaseNb, bRes);

                /** Test Case 6 : Offset+Length > COMPARE.length */
				testCaseNb = (byte) 6 ;
				bRes = false;

				try{
					MEProfile.check(COMPARE,(short)9,(short)9);
				}
				catch (ArrayIndexOutOfBoundsException e){
				    bRes = true;

				}

				reportTestOutcome(testCaseNb, bRes);


                /** Test Case 7 : length = 0 */
				testCaseNb = (byte)7 ;
				bRes = false;

				try {
					 bRes = MEProfile.check(COMPARE,(short)0,(short)0);
			    }
				catch (Exception e){
					bRes = false;
				}

				reportTestOutcome(testCaseNb, bRes);

				/** Test Case 8 : Check all the Terminal Profile */
				testCaseNb = (byte)8 ;
				bRes = false;

				try {
					 if (MEProfile.check(COMPARE,(short)0,(short)16)==false)
					    bRes =true;
				     else
					    bRes = false;
			    }
				catch (Exception e){
					bRes = false;
				}

				reportTestOutcome(testCaseNb, bRes);

				/** Test Case 9 : Check 2 first bytes of the Terminal Profile */
				testCaseNb = (byte) 9 ;
				bRes = false;

				try {
					bRes = MEProfile.check(COMPARE,(short)15,(short)2);

			    }
				catch (Exception e)
				{
					bRes = false;
				}

				reportTestOutcome(testCaseNb, bRes);

                /** Test Case 10 : Check facility 15 of the Terminal Profile */
				testCaseNb = (byte) 10 ;
				bRes = false;
				byte[] COMPARE2 = {(byte)0x00,(byte)0x80};

				try {
					 if (MEProfile.check(COMPARE2,(short)0,(short)2)==false)
						  bRes =true;
					 else
						  bRes = false;
			    }
				catch (Exception e){
					bRes = false;
				}

				reportTestOutcome(testCaseNb, bRes);
                // End of the Test Sequence
	    }
	}
}
