//-----------------------------------------------------------------------------
//    API_2_MEP_GVALSS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_mep_gvalss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV, EVENT_STATUS_COMMAND
 *
 */
public class API_2_MEP_GVALSS_1  extends TestToolkitApplet
{

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_MEP_GVALSS_1 () 
    {
		// Set Status Command as an activation event for the applet
		obReg.requestPollInterval(POLL_SYSTEM_DURATION);
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_MEP_GVALSS_1  thisApplet = new API_2_MEP_GVALSS_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes;
                
		if (event == EVENT_STATUS_COMMAND)
		{
		    /** Test Case 1 : ToolkitException ME_PROFILE_NOT_AVAILABLE is sent */
			testCaseNb = (byte) 1;
			bRes = false;
			try 
			{
				MEProfile.getValue((short)1, (short)0);
			}
			catch (ToolkitException e) 
			{
				if (e.getReason() == ToolkitException.ME_PROFILE_NOT_AVAILABLE) 
                    	bRes = true;
			}
			catch (Exception e) 
			{
         		  bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);
		}

		if (event == EVENT_FORMATTED_SMS_PP_ENV) 
		{

			/** Test Case 2 : Characters down ME Display */
			testCaseNb = (byte)2;
			bRes = false;
			try 
			{
				if (MEProfile.getValue((short)108, (short)104) == 13)
					bRes = true;
			}
			catch (Exception e) 
			{
				bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);

            /** Test Case 3 : Retreive byte 3 and 4 */
			testCaseNb = (byte)3;
			bRes = false;

			try 
			{
				if (MEProfile.getValue((short)31, (short)16) == (short)0xF0D2)
					bRes = true;
			}
			catch (Exception e) 
			{
				bRes = false;
			}
			reportTestOutcome(testCaseNb, bRes);

		    /** Test Case 4 : indexMSB < 0 */
			testCaseNb = (byte) 4;
			bRes = false;
			try 
			{
				MEProfile.getValue((short)0xFFFF, (short)0xFFFD);
			}
			catch (ToolkitException e) 
			{
				if (e.getReason() == ToolkitException.BAD_INPUT_PARAMETER) 
                    	bRes = true;
			}
			catch (Exception e) 
			{
         		  bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);

		    /** Test Case 5 : indexLSB < 0 */
			testCaseNb = (byte) 5;
			bRes = false;
			try 
			{
				MEProfile.getValue((short)0x0002, (short)0xFFFD);
			}
			catch (ToolkitException e) 
			{
				if (e.getReason() == ToolkitException.BAD_INPUT_PARAMETER) 
                    	bRes = true;
			}
			catch (Exception e) 
			{
         		  bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);

		    /** Test Case 6 : indexMSB < indexLSB */
			testCaseNb = (byte) 6;
			bRes = false;
			try 
			{
				MEProfile.getValue((short)0x0002, (short)0x0003);
			}
			catch (ToolkitException e) 
			{
				if (e.getReason() == ToolkitException.BAD_INPUT_PARAMETER) 
                    	bRes = true;
			}
			catch (Exception e) 
			{
         		  bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);

		    /** Test Case 7 : indexMSB > indexLSB + 16*/
			testCaseNb = (byte) 7;
			bRes = false;
			try 
			{
				MEProfile.getValue((short)0x0021, (short)0x0010);
			}
			catch (ToolkitException e) 
			{
				if (e.getReason() == ToolkitException.BAD_INPUT_PARAMETER) 
                    	bRes = true;
			}
			catch (Exception e) 
			{
         		  bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);

		    /** Test Case 8 : indexMSB = indexLSB + 16*/
			testCaseNb = (byte) 8;
			bRes = false;
			try 
			{
				MEProfile.getValue((short)0x0020, (short)0x0010);
			}
			catch (ToolkitException e) 
			{
				if (e.getReason() == ToolkitException.BAD_INPUT_PARAMETER) 
                    	bRes = true;
			}
			catch (Exception e) 
			{
         		  bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);

            /** Test Case 9 : indexMSB is outside data available */
			testCaseNb = (byte)9;
			bRes = false;

			try 
			{
				if (MEProfile.getValue((short)121, (short)115) == (short)0x001F)
					bRes = true;
			}
			catch (Exception e) 
			{
				bRes = false;
			}
			reportTestOutcome(testCaseNb, bRes);

		}
	}
}
