//-----------------------------------------------------------------------------
//    API_2_PRH_GLEN_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_prh_glen;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ProactiveResponseHandler.getLength() method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 07/12/00
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.ProactiveResponseHandler
 */
public class API_2_PRH_GLEN_1 extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;

    private byte[] TEXT = {(byte)'T',(byte)'e',(byte)'x',(byte)'t'} ;

    /**
     * Constructor of the applet
     */
    public API_2_PRH_GLEN_1() 
    {

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_PRH_GLEN_1 thisApplet = new API_2_PRH_GLEN_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
        // Response handler
        ProactiveResponseHandler proRespHdlr ;
        
        // --------------------------------------------
        // Test Case 1 : length = 12
        testCaseNb = (byte) 1 ;
        bRes = false ;
        
        try {
            
            // Build and send a proactive command
            proHdlr.initDisplayText((byte)0, DCS_8_BIT_DATA, TEXT, (short)0, (short)TEXT.length) ;
            proHdlr.send() ;
            
            // Get the response
            proRespHdlr = ProactiveResponseHandler.getTheHandler() ;
            
            // Verify length of the response
            bRes = (proRespHdlr.getLength() == (short)12) ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 2 : length = FFh
        testCaseNb = (byte) 2 ;
        bRes = false ;
        
        try {
            
            // Build and send a proactive command
            proHdlr.initDisplayText((byte)0, DCS_8_BIT_DATA, TEXT, (short)0, (short)TEXT.length) ;
            proHdlr.send() ;
            
            // Get the response
            proRespHdlr = ProactiveResponseHandler.getTheHandler() ;
            
            // Verify length of the response
            bRes = (proRespHdlr.getLength() == (short)0xFF) ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


    }
}
